/*
 * 助利宝账户变动记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class HelpProfitAccountRecordController : BaseController
    {
        public HelpProfitAccountRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 助利宝账户变动记录列表

        /// <summary>
        /// 根据条件查询助利宝账户变动记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(HelpProfitAccountRecord data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询助利宝账户变动记录列表

        /// <summary>
        /// 助利宝账户变动记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(HelpProfitAccountRecord data, string ChangeTypeSelect, string ProductTypeSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("TransRecordNo", "1"); //交易流水编号


            string condition = " and Status>-1";
            //变动类型
            if (!string.IsNullOrEmpty(ChangeTypeSelect))
            {
                condition += " and ChangeType=" + ChangeTypeSelect;
            }
            //产品类型
            if (!string.IsNullOrEmpty(ProductTypeSelect))
            {
                condition += " and ProductType=" + ProductTypeSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitAccountRecord", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //变动类型
                int ChangeType = int.Parse(dic["ChangeType"].ToString());
                if (ChangeType == 0) dic["ChangeType"] = " 激活奖励";
                if (ChangeType == 1) dic["ChangeType"] = " 交易分润";
                if (ChangeType == 2) dic["ChangeType"] = " 提现申请";
                if (ChangeType == 3) dic["ChangeType"] = " 提现代付";
                if (ChangeType == 4) dic["ChangeType"] = " 提现手续费";
                if (ChangeType == 5) dic["ChangeType"] = " 提现税点扣除";
                if (ChangeType == 6) dic["ChangeType"] = " 提现失败，解冻";
                if (ChangeType == 7) dic["ChangeType"] = " 系统扣除";
                if (ChangeType == 10) dic["ChangeType"] = " 办卡奖励";
                if (ChangeType == 20) dic["ChangeType"] = " 余额支付";
                if (ChangeType == 21) dic["ChangeType"] = " 余额支付退款";
                if (ChangeType == 22) dic["ChangeType"] = " 余额支付退款手续费";
                if (ChangeType == 30) dic["ChangeType"] = " 签到红包";
                if (ChangeType == 31) dic["ChangeType"] = " 系统红包奖励";
                //产品类型
                int ProductType = int.Parse(dic["ProductType"].ToString());
                if (ProductType == 0) dic["ProductType"] = "星支付";
                if (ProductType == 1) dic["ProductType"] = "在线办卡";
                if (ProductType == 2) dic["ProductType"] = "环迅大POS";
                if (ProductType == 3) dic["ProductType"] = "系统奖励";
                if (ProductType == 4) dic["ProductType"] = "灵动商城";
                if (ProductType == 99) dic["ProductType"] = "提现";

            }
            return Json(obj);
        }

        #endregion

        #region 增加助利宝账户变动记录

        /// <summary>
        /// 增加或修改助利宝账户变动记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加助利宝账户变动记录

        /// <summary>
        /// 增加或修改助利宝账户变动记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(HelpProfitAccountRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("HelpProfitAccountRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "HelpProfitAccountRecord", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改助利宝账户变动记录

        /// <summary>
        /// 增加或修改助利宝账户变动记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            HelpProfitAccountRecord editData = db.HelpProfitAccountRecord.FirstOrDefault(m => m.Id == Id) ?? new HelpProfitAccountRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改助利宝账户变动记录

        /// <summary>
        /// 增加或修改助利宝账户变动记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(HelpProfitAccountRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitAccountRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "HelpProfitAccountRecord", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除助利宝账户变动记录信息

        /// <summary>
        /// 删除助利宝账户变动记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitAccountRecord", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitAccountRecord", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitAccountRecord", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitAccountRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitAccountRecord", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitAccountRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("HelpProfitAccountRecord", Sort, Id);

            AddSysLog(Id.ToString(), "HelpProfitAccountRecord", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.HelpProfitAccountRecord.Add(new HelpProfitAccountRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "HelpProfitAccountRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(HelpProfitAccountRecord data, string ChangeTypeSelect, string ProductTypeSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("TransRecordNo", "1"); //交易流水编号


            string condition = " and Status>-1";
            //变动类型
            if (!string.IsNullOrEmpty(ChangeTypeSelect))
            {
                condition += " and ChangeType=" + ChangeTypeSelect;
            }
            //产品类型
            if (!string.IsNullOrEmpty(ProductTypeSelect))
            {
                condition += " and ProductType=" + ProductTypeSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitAccountRecord", Fields, "Id desc", "0", 1, 20000, condition, "UserId,ChangeType,ProductType,ChangeAmount,BeforeTotalAmount,AfterTotalAmount,BeforeFreezeAmount,AfterFreezeAmount,BeforeBalanceAmount,AfterBalanceAmount,Remark,TransRecordNo", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //变动类型
                int ChangeType = int.Parse(dic["ChangeType"].ToString());
                if (ChangeType == 0) dic["ChangeType"] = " 激活奖励";
                if (ChangeType == 1) dic["ChangeType"] = " 交易分润";
                if (ChangeType == 2) dic["ChangeType"] = " 提现申请";
                if (ChangeType == 3) dic["ChangeType"] = " 提现代付";
                if (ChangeType == 4) dic["ChangeType"] = " 提现手续费";
                if (ChangeType == 5) dic["ChangeType"] = " 提现税点扣除";
                if (ChangeType == 6) dic["ChangeType"] = " 提现失败，解冻";
                if (ChangeType == 7) dic["ChangeType"] = " 系统扣除";
                if (ChangeType == 10) dic["ChangeType"] = " 办卡奖励";
                if (ChangeType == 20) dic["ChangeType"] = " 余额支付";
                if (ChangeType == 21) dic["ChangeType"] = " 余额支付退款";
                if (ChangeType == 22) dic["ChangeType"] = " 余额支付退款手续费";
                if (ChangeType == 30) dic["ChangeType"] = " 签到红包";
                if (ChangeType == 31) dic["ChangeType"] = " 系统红包奖励";
                //产品类型
                int ProductType = int.Parse(dic["ProductType"].ToString());
                if (ProductType == 0) dic["ProductType"] = "星支付";
                if (ProductType == 1) dic["ProductType"] = "在线办卡";
                if (ProductType == 2) dic["ProductType"] = "环迅大POS";
                if (ProductType == 3) dic["ProductType"] = "系统奖励";
                if (ProductType == 4) dic["ProductType"] = "灵动商城";
                if (ProductType == 99) dic["ProductType"] = "提现";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserId", "创客");
            ReturnFields.Add("ChangeType", "变动类型");
            ReturnFields.Add("ProductType", "产品类型");
            ReturnFields.Add("ChangeAmount", "变更金额");
            ReturnFields.Add("BeforeTotalAmount", "变更前总金额");
            ReturnFields.Add("AfterTotalAmount", "变更后总金额");
            ReturnFields.Add("BeforeFreezeAmount", "变更前冻结金额");
            ReturnFields.Add("AfterFreezeAmount", "变更后冻结金额");
            ReturnFields.Add("BeforeBalanceAmount", "变更前余额");
            ReturnFields.Add("AfterBalanceAmount", "变更后余额");
            ReturnFields.Add("Remark", "账户变动明细备注信息");
            ReturnFields.Add("TransRecordNo", "交易流水编号");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "HelpProfitAccountRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
